import { ComponentPropsWithoutRef } from 'react';
import { UiFunction } from './utilities';
interface IBackdrop extends ComponentPropsWithoutRef<'div'> {
    isVisible?: boolean;
}
export declare const Backdrop: ({ children, isVisible }: IBackdrop) => JSX.Element;
interface IBtn extends ComponentPropsWithoutRef<'button'> {
    isFullWidth?: boolean;
    uiFunction?: UiFunction;
}
export declare const Btn: ({ children, isFullWidth, uiFunction, ...rest }: IBtn) => JSX.Element;
interface ICard extends ComponentPropsWithoutRef<'div'> {
}
export declare const Card: ({ children }: ICard) => JSX.Element;
interface ICardBody extends ComponentPropsWithoutRef<'div'> {
}
export declare const CardBody: ({ children }: ICardBody) => JSX.Element;
interface ICardText extends ComponentPropsWithoutRef<'div'> {
}
export declare const CardText: ({ children }: ICardText) => JSX.Element;
interface ICardTitle extends ComponentPropsWithoutRef<'h5'> {
}
export declare const CardTitle: ({ children }: ICardTitle) => JSX.Element;
interface ICloseButton extends ComponentPropsWithoutRef<'button'> {
}
export declare const CloseButton: ({ ...rest }: ICloseButton) => JSX.Element;
interface IDropdown extends ComponentPropsWithoutRef<'div'> {
}
export declare const Dropdown: ({ children }: IDropdown) => JSX.Element;
interface IDropdownMenu extends ComponentPropsWithoutRef<'div'> {
    isExpanded: boolean;
}
export declare const DropdownMenu: ({ children, isExpanded }: IDropdownMenu) => JSX.Element;
interface IFloatingTextBox extends ComponentPropsWithoutRef<'input'> {
    helpText?: string;
    label: string;
    name: string;
    value: string;
}
export declare const FloatingTextBox: ({ helpText, label, name, value, ...rest }: IFloatingTextBox) => JSX.Element;
export declare const HamburgerIcon: () => JSX.Element;
interface IMasonry extends ComponentPropsWithoutRef<'div'> {
}
export declare const Masonry: ({ children }: IMasonry) => JSX.Element;
interface IModalBody extends ComponentPropsWithoutRef<'div'> {
}
export declare const ModalBody: ({ children }: IModalBody) => JSX.Element;
interface IModalContent extends ComponentPropsWithoutRef<'div'> {
}
export declare const ModalContent: ({ children }: IModalContent) => JSX.Element;
interface IModalDialog extends ComponentPropsWithoutRef<'div'> {
}
export declare const ModalDialog: ({ children }: IModalDialog) => JSX.Element;
interface IModalFooter extends ComponentPropsWithoutRef<'div'> {
}
export declare const ModalFooter: ({ children }: IModalFooter) => JSX.Element;
interface IModalHeader extends ComponentPropsWithoutRef<'div'> {
}
export declare const ModalHeader: ({ children }: IModalHeader) => JSX.Element;
interface INavBar extends ComponentPropsWithoutRef<'nav'> {
    isFixedTop?: boolean;
}
export declare const NavBar: ({ children, isFixedTop }: INavBar) => JSX.Element;
interface INavBarToggler extends ComponentPropsWithoutRef<'button'> {
    isVisible?: boolean;
}
export declare const NavBarToggler: ({ isVisible, ...rest }: INavBarToggler) => JSX.Element | null;
interface INavBarCollapse extends ComponentPropsWithoutRef<'div'> {
    isVertical?: boolean;
    isVisible?: boolean;
}
export declare const NavBarCollapse: ({ children, isVertical, isVisible }: INavBarCollapse) => JSX.Element;
interface INavBarNav extends ComponentPropsWithoutRef<'div'> {
    isVertical?: boolean;
}
export declare const NavBarNav: ({ children, isVertical }: INavBarNav) => JSX.Element;
export {};
