"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NavBarNav = exports.NavBarCollapse = exports.NavBarToggler = exports.NavBar = exports.ModalHeader = exports.ModalFooter = exports.ModalDialog = exports.ModalContent = exports.ModalBody = exports.Masonry = exports.HamburgerIcon = exports.FloatingTextBox = exports.DropdownMenu = exports.Dropdown = exports.CloseButton = exports.CardTitle = exports.CardText = exports.CardBody = exports.Card = exports.Btn = exports.Backdrop = void 0;
const react_1 = __importStar(require("react"));
const web_1 = require("@react-spring/web");
const utilities_1 = require("./utilities");
const s = __importStar(require("./styles"));
const Backdrop = ({ children, isVisible = false }) => {
    const styles = (0, web_1.useSpring)({
        config: web_1.config.stiff,
        opacity: isVisible ? 1 : 0,
        zIndex: isVisible ? 2000 : -1,
        ...s.Backdrop,
    });
    return react_1.default.createElement(web_1.animated.div, { style: styles }, children);
};
exports.Backdrop = Backdrop;
const Btn = ({ children, isFullWidth = false, uiFunction = utilities_1.UiFunction.None, ...rest }) => {
    const [baseStyle, setBaseStyle] = (0, react_1.useState)(s.Btn);
    const [finalStyle, setFinalStyle] = (0, react_1.useState)(s.Btn);
    const [focusStyle, setFocusStyle] = (0, react_1.useState)(s.Btn);
    const [hoverStyle, setHoverStyle] = (0, react_1.useState)(s.Btn);
    const [isHovering, setIsHovering] = (0, react_1.useState)(false);
    const [isFocused, setIsFocused] = (0, react_1.useState)(false);
    (0, react_1.useEffect)(() => {
        switch (uiFunction) {
            case utilities_1.UiFunction.Light:
                setBaseStyle(s.BtnLight);
                setFocusStyle(s.BtnLightFocus);
                setHoverStyle(s.BtnLightHover);
                setFinalStyle(s.BtnLight);
                break;
            case utilities_1.UiFunction.Primary:
                setBaseStyle(s.BtnPrimary);
                setFocusStyle(s.BtnPrimaryFocus);
                setHoverStyle(s.BtnPrimaryHover);
                setFinalStyle(s.BtnPrimary);
                break;
            case utilities_1.UiFunction.Secondary:
                setBaseStyle(s.BtnSecondary);
                setFocusStyle(s.BtnSecondaryFocus);
                setHoverStyle(s.BtnSecondaryHover);
                setFinalStyle(s.BtnSecondary);
                break;
        }
    }, [uiFunction]);
    (0, react_1.useEffect)(() => {
        if (isFocused) {
            setFinalStyle(focusStyle);
            return;
        }
        if (isHovering) {
            setFinalStyle(hoverStyle);
            return;
        }
        setFinalStyle(baseStyle);
    }, [isFocused, isHovering, baseStyle]);
    return (react_1.default.createElement("button", { style: { ...finalStyle, width: (isFullWidth) ? '100%' : 'auto' }, ...rest, onMouseEnter: () => { setIsHovering(true); }, onMouseLeave: () => { setIsHovering(false); }, onFocus: () => { setIsFocused(true); }, onBlur: () => { setIsFocused(false); } }, children));
};
exports.Btn = Btn;
const Card = ({ children }) => {
    return react_1.default.createElement("div", { style: s.Card }, children);
};
exports.Card = Card;
const CardBody = ({ children }) => {
    return react_1.default.createElement("div", { style: s.CardBody }, children);
};
exports.CardBody = CardBody;
const CardText = ({ children }) => {
    return react_1.default.createElement("div", { style: s.CardText }, children);
};
exports.CardText = CardText;
const CardTitle = ({ children }) => {
    return react_1.default.createElement("h5", { style: s.CardTitle }, children);
};
exports.CardTitle = CardTitle;
const CloseButton = ({ ...rest }) => {
    const [finalStyle, setFinalStyle] = (0, react_1.useState)(s.CloseButton);
    const [isHovering, setIsHovering] = (0, react_1.useState)(false);
    (0, react_1.useEffect)(() => {
        const newStyle = {
            ...s.CloseButton,
            opacity: (isHovering) ? '.5' : 1
        };
        setFinalStyle(newStyle);
    }, [isHovering]);
    return (react_1.default.createElement("button", { style: finalStyle, ...rest, onMouseEnter: () => { setIsHovering(true); }, onMouseLeave: () => { setIsHovering(false); } }));
};
exports.CloseButton = CloseButton;
const Dropdown = ({ children }) => {
    return (react_1.default.createElement("div", { style: s.Dropdown }, children));
};
exports.Dropdown = Dropdown;
const DropdownMenu = ({ children, isExpanded = false }) => {
    return (react_1.default.createElement("div", { style: { ...s.DropdownMenu, display: (isExpanded) ? 'block' : 'none' } }, children));
};
exports.DropdownMenu = DropdownMenu;
const FloatingTextBox = ({ helpText, label, name, value, ...rest }) => {
    const textboxId = name + "Textbox";
    const [inputStyle, setInputStyle] = (0, react_1.useState)(s.FormFloatingFormControl);
    const [labelStyle, setLabelStyle] = (0, react_1.useState)(s.FloatingLabel);
    (0, react_1.useEffect)(() => {
        if (value) {
            setLabelStyle(s.FloatingLabelFocus);
        }
    }, []);
    const thisFocus = (e) => {
        setInputStyle({
            ...s.FormControlFocus,
            ...s.FormFloatingFormControl,
        });
        setLabelStyle(s.FloatingLabelFocus);
    };
    const thisBlur = (e) => {
        if (!e.target.value || e.target.value.length === 0) {
            setLabelStyle(s.FloatingLabel);
        }
        setInputStyle(s.FormFloatingFormControl);
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { style: s.FormFloating },
            react_1.default.createElement("input", { style: inputStyle, id: textboxId, name: name, onFocus: (e) => { e.target.select(); thisFocus(e); }, onBlur: (e) => { thisBlur(e); }, value: value, ...rest }),
            react_1.default.createElement("label", { style: labelStyle, htmlFor: textboxId }, label)),
        (helpText && helpText.length > 0)
            ? react_1.default.createElement("div", { style: { fontSize: '.875em', marginTop: '0.25rem', opacity: '0.7' } }, helpText)
            : null));
};
exports.FloatingTextBox = FloatingTextBox;
const HamburgerIcon = () => {
    return (react_1.default.createElement("span", { style: s.NavBarTogglerIcon }));
};
exports.HamburgerIcon = HamburgerIcon;
const Masonry = ({ children }) => {
    const columnCount = (0, utilities_1.useMasonryColumns)();
    const [columns, setColumns] = (0, react_1.useState)([]);
    (0, react_1.useEffect)(() => {
        const newCols = [];
        const colWidth = (100 / columnCount) + '%';
        const colStyle = {
            ...s.MasonryCol,
            width: colWidth,
        };
        if (children) {
            const childArray = children;
            for (let i = 0; i < columnCount; i++) {
                const rows = [];
                for (let j = i; j < childArray.length; j += columnCount) {
                    rows.push(react_1.default.createElement("div", { key: j, style: s.MasonryBrick }, childArray[j]));
                }
                newCols.push(react_1.default.createElement("div", { key: i, style: colStyle }, rows));
            }
            setColumns(newCols);
        }
        else {
            setColumns([]);
        }
    }, [children, columnCount]);
    return (react_1.default.createElement("div", { style: s.Masonry }, columns));
};
exports.Masonry = Masonry;
const ModalBody = ({ children }) => {
    return (react_1.default.createElement("div", { style: s.ModalBody }, children));
};
exports.ModalBody = ModalBody;
const ModalContent = ({ children }) => {
    return (react_1.default.createElement("div", { style: s.ModalContent }, children));
};
exports.ModalContent = ModalContent;
const ModalDialog = ({ children }) => {
    const [style, setStyle] = (0, react_1.useState)(s.ModalDialog);
    const width = (0, utilities_1.useMedia)(['(min-width: 576px)'], [1], 0);
    (0, react_1.useEffect)(() => {
        if (width === 0)
            setStyle({
                ...s.ModalDialog,
                width: '100%',
                margin: '.75rem'
            });
        else
            setStyle({
                ...s.ModalDialog,
                width: '500px'
            });
    }, [width]);
    return (react_1.default.createElement("div", { style: style }, children));
};
exports.ModalDialog = ModalDialog;
const ModalFooter = ({ children }) => {
    return (react_1.default.createElement("div", { style: s.ModalFooter }, children));
};
exports.ModalFooter = ModalFooter;
const ModalHeader = ({ children }) => {
    return (react_1.default.createElement("div", { style: s.ModalHeader }, children));
};
exports.ModalHeader = ModalHeader;
const NavBar = ({ children, isFixedTop = false }) => {
    let finalStyle = s.NavBar;
    if (isFixedTop && isFixedTop === true)
        finalStyle = {
            ...s.NavBar,
            ...s.FixedTop,
            backgroundColor: '#f8f9fa'
        };
    return (react_1.default.createElement("nav", { style: finalStyle }, children));
};
exports.NavBar = NavBar;
const NavBarToggler = ({ isVisible = true, ...rest }) => {
    const [finalStyle, setFinalStyle] = (0, react_1.useState)(s.NavBarToggler);
    if (isVisible === true)
        return (react_1.default.createElement("button", { type: 'button', style: finalStyle, ...rest, onFocus: () => { setFinalStyle(s.NavBarTogglerFocus); }, onBlur: () => { setFinalStyle(s.NavBarToggler); } },
            react_1.default.createElement("span", { style: s.NavBarTogglerIcon })));
    return null;
};
exports.NavBarToggler = NavBarToggler;
const NavBarCollapse = ({ children, isVertical = false, isVisible = true }) => {
    const [finalStyle, setFinalStyle] = (0, react_1.useState)(s.NavBarCollapseVer);
    (0, react_1.useEffect)(() => {
        let newStyle = (isVertical === true)
            ? s.NavBarCollapseVer
            : s.NavBarCollapseHor;
        if (isVisible === false)
            newStyle = {
                ...newStyle,
                display: 'none'
            };
        setFinalStyle(newStyle);
    }, [isVertical, isVisible]);
    return (react_1.default.createElement("div", { style: { ...finalStyle } }, children));
};
exports.NavBarCollapse = NavBarCollapse;
const NavBarNav = ({ children, isVertical = false }) => {
    const [finalStyle, setFinalStyle] = (0, react_1.useState)(s.NavBarNavVer);
    (0, react_1.useEffect)(() => {
        if (isVertical === true)
            setFinalStyle(s.NavBarNavVer);
        else
            setFinalStyle(s.NavBarNavHor);
    }, [isVertical]);
    return (react_1.default.createElement("div", { style: finalStyle }, children));
};
exports.NavBarNav = NavBarNav;
//# sourceMappingURL=components.js.map