import { CSSProperties } from 'react';
export declare const defaultQueries: string[];
export declare const isBrowser: false | (Window & typeof globalThis);
export declare const masonryQueries: string[];
export declare enum Size {
    sm = 0,
    md = 1,
    lg = 2,
    xl = 3,
    xxl = 4,
    fluid = 5
}
export declare enum UiFunction {
    None = 0,
    Primary = 1,
    Secondary = 2,
    Success = 3,
    Danger = 4,
    Warning = 5,
    Info = 6,
    Light = 7,
    Dark = 8,
    Link = 9
}
export declare function useColumnSizes(size: Size, colSpan: number): CSSProperties;
export declare function useContainerSizes(size: Size): string;
export declare function useMasonryColumns(): number;
export declare function useMedia<T>(queries: string[], values: T[], defaultValue: T): T;
export declare function useWindowSize(): {
    width: number;
    height: number;
};
